#!/bin/bash

#1.жǷΪԱȨ
if [ "`id -u`" -ne 0 ]
then
    echo -e -n "\033[31m[ERROR:7]\033[0m ";echo "Log in as the root user only."
    exit 1
fi
i10s_fullPath="${0}"

if [ `echo "${i10s_fullPath}"|grep -c "/"` -ne 0 ] && [ "${i10s_fullPath%/*}" != "" ]
then
    cd "${i10s_fullPath%/*}"
fi
if [ `pwd|grep -c " "` -ne 0 ]
then
    echo -e -n "\033[31m[ERROR:7]\033[0m ";echo "There is space key in the directory[`pwd`]."
    exit 1
fi

readonly i10s_lockFile="/var/lock/UltraPath-for-vCenter_install.shell.lock"
readonly VMWARE_DIR="/etc/vmware/vsphere-client"
readonly VMWARE_ULTRAPATH_DIR=/etc/vmware/vsphere-client/vc-packages/vsphere-client-serenity/
g10s_exitFun="i10s_exit"
readonly i10s_baseDir="`pwd`"
readonly i10s_packageDir="`pwd`/packages"
readonly plugin_version_Cversion=02
readonly plugin_version=46
readonly i10s_packageName="UltraPath-21.${plugin_version_Cversion}.0${plugin_version}-vCenter6.rpm"

readonly g10s_id=`id -u`

#2.ǷѰװvCenter
if [ "${VMWARE_CFG_DIR}" = "" ]
then
    echo -e -n "{VMWARE_CFG_DIR}:\033[31m[ERROR:7]\033[0m ";echo "The environmental variable VMWARE_CFG_DIR does not exist. Please check whether vCenter 6 has been installed."
	exit 1
fi

if [ ! -d ${VMWARE_DIR} ]
then
    echo -e -n "VMWARE_DIR:\033[31m[ERROR:7]\033[0m ";echo "The VMWARE_CFG_DIR dir is missing. Please check whether vCenter 6 has been installed."
	exit 1
fi

#װ־
g10s_logDir=/opt/UltraPath/log
g10_logup="/opt/UltraPath/"
    [ "${g10s_logDir}" != "" ] && mkdir -p "${g10s_logDir}"
    chmod 600 "${g10_logup}"
    g10s_logName=${g10s_logName:="UltraPath-For-vCenter6-Setup.log"}

    g10s_logFile=${g10s_logFile="${g10s_logDir}/${g10s_logName}"}
    if [ "${g10s_logFile}" != "" ] && [ ! -f "${g10s_logFile}" ]
    then
        touch "${g10s_logFile}"
    fi
	
function i10s_exit()
{
    g10s_unlockShell "${i10s_lockFile}"
    exit $1
}
	
function print_debug()
{
    local fileFlag=""

    if [ "$2" != "" ]
    then
        fileFlag=$2
    else
        fileFlag=${0##*/}
        fileFlag=${fileFlag%%_*}
    fi

    [ "${g10s_logFile}" != "" ] && [ -w "${g10s_logFile}" ] && echo "[EVENT:0][${fileFlag}][`date +%Y-%m-%d_%H:%M:%S`][${g10s_id}][$0,${FUNCNAME[1]},${BASH_LINENO[0]}] $1">>"${g10s_logFile}"
    return 0
}	

    function print_event()
    {
        local fileFlag=""

        if [ `echo "$1"|grep -E -c "[0-9]+"` -eq 0 ] || [ "$2" = "" ]
        then
            echo -e -n "\033[31m[ERROR:2][ultrapathPlugin][`date +%Y-%m-%d_%H:%M:%S`][$0,${FUNCNAME[1]},${BASH_LINENO[0]}]\033[0m ";echo "param error[$1,$2]"
            [ "${g10s_logFile}" != "" ] && [ -w "${g10s_logFile}" ] && echo "[ERROR:2][ultrapathPlugin][`date +%Y-%m-%d_%H:%M:%S`][${g10s_id}][$0,${FUNCNAME[1]},${BASH_LINENO[0]}] param error[$1,$2]" >> "${g10s_logFile}"
            eval "${g10s_exitFun} 1"
        fi
        if [ "$3" != "" ]
        then
            fileFlag=$3
        else
            fileFlag=${0##*/}
            fileFlag=${fileFlag%%_*}
        fi

        echo "$2"
        [ "${g10s_logFile}" != "" ] && [ -w "${g10s_logFile}" ] && echo "[EVENT:$1][${fileFlag}][`date +%Y-%m-%d_%H:%M:%S`][${g10s_id}][$0,${FUNCNAME[1]},${BASH_LINENO[0]}] $2">>"${g10s_logFile}"
        return 0
    }

    function print_warning()
    {
        local fileFlag=""

        if [ "$2" = "" ] || [ `echo "$1"|grep -E -c "[0-9]+"` -eq 0 ]
        then
            echo -e -n "\033[31m[ERROR:2][ultrapathPlugin][`date +%Y-%m-%d_%H:%M:%S`][$0,${FUNCNAME[1]},${BASH_LINENO[0]}]\033[0m ";echo "param error[$1,$2]"
            [ "${g10s_logFile}" != "" ] && [ -w "${g10s_logFile}" ] && echo  "[ERROR:2][ultrapathPlugin][`date +%Y-%m-%d_%H:%M:%S`][${g10s_id}][$0,${FUNCNAME[1]},${BASH_LINENO[0]}] param error[$1,$2]" >> "${g10s_logFile}"

            eval "${g10s_exitFun} 1"
        fi
        if [ "$3" != "" ]
        then
            fileFlag=$3
        else
            fileFlag=${0##*/}
            fileFlag=${fileFlag%%_*}
        fi

		echo -e -n "\033[35m[WARNING]\033[0m ";echo "$2"
        [ "${g10s_logFile}" != "" ] && [ -w "${g10s_logFile}" ] && echo  "[WARNING:$1][${fileFlag}][`date +%Y-%m-%d_%H:%M:%S`][${g10s_id}][$0,${FUNCNAME[1]},${BASH_LINENO[0]}] $2">>"${g10s_logFile}"

        return 0
    }

    function print_error()
    {
        local fileFlag=""
        local tmpDebugon=""

        if [ "$2" = "" ] || [ `echo "$1"|grep -E -c "[0-9]+"` -eq 0 ]
        then
            echo -e -n "\033[31m[ERROR:2][ultrapathPlugin][`date +%Y-%m-%d_%H:%M:%S`][$0,${FUNCNAME[1]},${BASH_LINENO[0]}]\033[0m ";echo "param error[$1,$2]"
            [ "${g10s_logFile}" != "" ] && [ -w "${g10s_logFile}" ] && echo "[ERROR:2][ultrapathPlugin][`date +%Y-%m-%d_%H:%M:%S`][${g10s_id}][$0,${FUNCNAME[1]},${BASH_LINENO[0]}] param error[$1,$2]" >> "${g10s_logFile}"
            eval "${g10s_exitFun} 1"
        fi
        if [ "$3" != "" ]
        then
            fileFlag=$3
        else
            fileFlag=${0##*/}
            fileFlag=${fileFlag%%_*}
        fi
		
		echo -e -n "\033[31m[ERROR]\033[0m ";echo "$2"
        [ "${g10s_logFile}" != "" ] && [ -w "${g10s_logFile}" ] && echo  "[ERROR:$1][${fileFlag}][`date +%Y-%m-%d_%H:%M:%S`][${g10s_id}][$0,${FUNCNAME[1]},${BASH_LINENO[0]}] $2">>"${g10s_logFile}"

        return 0
    }
	
	function g10s_lower()
    {
       echo "$1"|tr '[A-Z]' '[a-z]'
       return 0
    }

	function print_yesOrNo()
    {
        local fileFlag=""
        local userInput=""
        local isoutputyes=""

        if [ "$2" = "" ] || [ `echo "$1"|grep -E -c "[0-9]+"` -eq 0 ]
        then
            print_error "2" "param error[$1,$2]" "ultrapathPlugin"
            eval "${g10s_exitFun} 1"
        fi
        if [ "$3" != "" ]
        then
            fileFlag=$3
        else
            fileFlag=${0##*/}
            fileFlag=${fileFlag%%_*}
        fi

        if [ "$4" != "" ]
        then
            isoutputyes="yes"
        fi

        while [ 1 -eq 1 ]
        do
			echo "------------begin-----------YES or NO box---------------------------"
			
            echo "$2"
            [ "${g10s_logFile}" != "" ] && echo "[YESORNO:$1][${fileFlag}][`date +%Y-%m-%d_%H:%M:%S`][$0,${FUNCNAME[1]},${BASH_LINENO[0]}] " >> "${g10s_logFile}"
            [ "${g10s_logFile}" != "" ] && echo "$2" >> "${g10s_logFile}"

			echo "------------end-------------YES or NO box---------------------------"

            if [ "${isoutputyes}" != "" ]
            then
                echo -n "<yes|no>:"
            else
                echo -n "<Y|N>:"
            fi


            read userInput
            userInput=$(g10s_lower "${userInput}")
            if [ "${userInput}" != "yes" ] && \
                [ "${userInput}" != "y" ] && \
                [ "${userInput}" != "no" ] && \
                [ "${userInput}" != "n" ]
            then
                print_warning "31" "you select is incorrect[${userInput}]" "ultrapathPlugin"
                continue
            fi

            print_debug "your selection is [${userInput}]" "ultrapathPlugin"
            if [ "${userInput}" = "yes" ] || \
                    [ "${userInput}" = "y" ]
            then
                return 0
            else
                return 1
            fi
        done
        return 0
    }
	
    function checkDiskSpace()
    {
        local spaceStr=""
        local freeSpace=""

        if [ -z "$1" ] || [ -z "$2" ]
        then 
		    print_error "2" "param error[$1,$2]" "ultrapathPlugin"
			eval "${g10s_exitFun} 1"
        fi
        spaceStr=`df -k "$1" 2>/dev/null | sed -n '$p' |  grep ".*[[:blank:]][[:blank:]]*[0-9][0-9]*[[:blank:]][[:blank:]]*[0-9][0-9]*%[[:blank:]][[:blank:]]*/.*$"`
        if [ "${spaceStr}" = "" ]
        then
		    print_error "10" "Getting free disk space failed.[$1]" "ultrapathPlugin"
			eval "${g10s_exitFun} 1"
        fi

        freeSpace=`df -k "$1" 2>/dev/null | sed -n '$p' | grep ".*[[:blank:]][[:blank:]]*[0-9][0-9]*[[:blank:]][[:blank:]]*[0-9][0-9]*%[[:blank:]][[:blank:]]*/.*$" | awk '{print $(NF-2)}'`
        if [ -z "${freeSpace}" ] || [ ${freeSpace} -lt $2 ]
        then
            let freeSpaceSize="$2"/1000
            print_error "11" "The free space of the disks should be more than 200 MB for installing UltraPath for vCenter." "ultrapathPlugin"
			eval "${g10s_exitFun} 1"
        fi
        return 0
    }
	
    function g10s_lockShell()
    {
        local thepid=""
        local ret=""

        if [ "$1" = "" ]
        then
            print_error "2" "need a param" "ultrapathPlugin"
            exit 1
        fi
        print_debug "lock shell[${1}]" "ultrapathPlugin"
        if [ -f "${1}" ]
        then
          thepid=`cat "${1}"`
          if [ "${thepid}" != "" ]
          then
              ret=`ps ax |awk '{print $1}'| grep -c "^[[:blank:]]*${thepid}[[:blank:]]*$"`
              if [ ${ret} -eq 1 ]
              then
                  print_error "18" "Only one installation program can run." "ultrapathPlugin"
                  [ "${g10s_logFile}" != "" ] && ps aux>>"${g10s_logFile}" 2>&1
                  exit 1
              fi
          fi
        fi
         echo $$ > "${1}"
         return 0
    }

    function g10s_unlockShell()
    {
        if [ "$1" = "" ]
        then
            print_error "2" "need a param" "ultrapathPlugin"

            exit 1
        fi
        if [ -f "${1}" ]
        then
            print_debug "unlock shell[${1}]" "ultrapathPlugin"
            rm -f "${1}"
        fi
        return 0
    }

#
g10s_lockShell "${i10s_lockFile}"	
	
#3.װ&&ҪļǷڣռ乻
checkDiskSpace "${VMWARE_DIR}" 200000

#4.ɾļ
#ڵĻļ
function i10s_uninstallOldUltraPath()
{
    rm -f /tmp/ultrapath.uninstall.bj
    print_event "1020" "The UltraPath for vCenter uninstallation starts."
	print_debug "start rpm -e" "ultrapathPlugin"
    rpm -e UltraPath-for-vCenter | awk '{if ($0 ~ /UltraPath for vCenter has been successfully uninstalled/){system("touch /tmp/ultrapath.uninstall.bj")}else{ print $0}}'
    if [ ! -f /tmp/ultrapath.uninstall.bj ]
    then
        print_error "1021" "Uninstalling UltraPath for vCenter of an earlier version failed."
        i10s_exit  1
    fi
    rm -f /tmp/ultrapath.uninstall.bj
	print_debug "rpm -e finished." "ultrapathPlugin"

    oldRpm=`rpm -qa | grep -E "UltraPath-for-vCenter"`
    if [ "${oldRpm}" = "" ]
    then
        i10s_oldUltraPathType="NULL"
		print_event "1021" "Uninstalling UltraPath for vCenter of an earlier version succeeded."
    else
        print_error "1023" "Uninstalling UltraPath for vCenter of an earlier version failed."
        i10s_exit  1
    fi
	
    return 0
}

function i10s_installForRPM()
{
    rm -f /tmp/ultrapath.install.bj
	print_debug "start rpm -ivh" "ultrapathPlugin"
    rpm -ivh --nodeps "${i10s_packageDir}/${i10s_packageName}" 2>&1|awk '{if ($0 ~ /UltraPath for vCenter has been successfully installed/){system("touch /tmp/ultrapath.install.bj")}else{ print $0}}'
    if [ -f /tmp/ultrapath.install.bj ]
    then
        rm -f /tmp/ultrapath.install.bj
		print_debug "rpm -ivh finished" "ultrapathPlugin"
        return 0
    fi
    return 1
}

function i10s_importOEM()
{

        if [ ! -f packages/Config/ultrapathplugin.war ]
        then
            print_error "1005" "The ultrapathplugin.war file in Config folder is missing."
			i10s_exit 1
        else
            cp -f packages/Config/ultrapathplugin.war "${VMWARE_ULTRAPATH_DIR}/com.storage.issp.ultrapathplugin-21.${plugin_version_Cversion}.${plugin_version}/plugins"
            if [ $? -ne 0 ]
            then
                print_error "1018" "Importing ultrapathplugin.war file failed."
		    else
				print_debug "Copy ultrapathplugin.war to the ultrapathplugin dir succeed." "ultrapathPlugin"
            fi
        fi
    
    return 0
}

if [ ! -d ${VMWARE_ULTRAPATH_DIR} ]
then
    mkdir -p "${VMWARE_ULTRAPATH_DIR}"
	print_debug "mkdir [${VMWARE_ULTRAPATH_DIR}] succeed." "ultrapathPlugin"
else
    oldRpm=`rpm -qa | grep -E "UltraPath-for-vCenter"`
    if [ "${oldRpm}" = "" ]
    then
        i10s_oldUltraPathType="NULL"
		
		#ûװrpmļУʾǷɾļ
	    cd ${VMWARE_ULTRAPATH_DIR}
        oldDir=`ls |grep com.storage.issp.ultrapathplugin`
	    if [ ! "${oldDir}" = "" ]
        then
	        #ļУʾǷɾļ
            print_warning "1030" "The UltraPath directory of an earlier version has been detected."
            g10s_defaultSelect="Y"
            print_yesOrNo "1019" "Do you want to remove it now?"
	        if [ $? -ne 0 ]
            then
                i10s_exit 2
            fi
		
            print_event "1100" "Start to delete UltraPath-for-vCenter dir of an earlier version."		
            ls -d */ |grep com.storage.issp.ultrapathplugin |xargs rm -rf
	        print_event "1101" "Deleting UltraPath-for-vCenter dir of an earlier version succeeds."
	    else
	        print_debug "There are no old UltraPath-for-vCenter dir." "ultrapathPlugin"
	    fi
	    cd ${i10s_baseDir}	
		
    else
        iCount=`echo "${oldRpm}"|wc -l`
        if [ ${iCount} -ge 2 ]
        then
            print_error "1013" "There are multiple UltraPath for vCenter programs.[count=${iCount}]"
            i10s_exit 1
        fi
		#Ϊϰ汾ͬ汾ʾ˳
		oldV1orV21version=`echo ${oldRpm} |awk -F "." '{print $1}' |awk -F "-" '{print $4}'`
		oldversion=`echo ${oldRpm} |awk -F "." '{print $3}' |awk -F "-" '{print $1}'`
		oldversion_Cversion=`echo ${oldRpm} |awk -F "." '{print $2}'`
		#ΪV1汾ֱжC汾źС汾
		if [ ${oldV1orV21version} -ne 1 ]
		then
		    #V2汾Ѱװ汾C汾Ŵڴװ汾ʾֱ˳
		    if [ ${oldversion_Cversion} -gt ${plugin_version_Cversion} ]
            then
                print_error "1013" "Current version is ${oldRpm}. A degrade is not supported."
                i10s_exit 1
            fi 
			
			#V2汾Ѱװ汾C汾==װ汾жС汾
		    if [ ${oldversion_Cversion} -eq ${plugin_version_Cversion} ]
            then
                if [ ${oldversion} -gt ${plugin_version} ]
                then
                    print_error "1013" "Current version is ${oldRpm}. A degrade is not supported."
                    i10s_exit 1
                fi
	            if [ ${oldversion} -eq ${plugin_version} ]
                then
                    print_error "1013" "Current version is ${oldRpm}. An upgrade is not supported ."
                    i10s_exit 1
                fi
            fi 	
		fi
		
        #ֻװһʾǷж
		print_warning "1030" "An earlier UltraPath version has been detected."
        g10s_defaultSelect="Y"
        print_yesOrNo "1019" "Do you want to remove it now?"
		if [ $? -ne 0 ]
        then
            i10s_exit 2
        fi
		
        i10s_uninstallOldUltraPath
		
		#rpmжغļУ򣬲ɾļ
	    cd ${VMWARE_ULTRAPATH_DIR}
        oldDir=`ls |grep com.storage.issp.ultrapathplugin`
	    if [ ! "${oldDir}" = "" ]
        then
	        #rpmжغļУ򣬲ɾļ
            print_debug "1030" "The UltraPath directory of an earlier version has been detected." "ultrapathPlugin"	
            print_debug "Start to delete UltraPath-for-vCenter dir of an earlier version." "ultrapathPlugin"		
            ls -d */ |grep com.storage.issp.ultrapathplugin |xargs rm -rf
	        print_debug "Deleting UltraPath-for-vCenter dir of an earlier version succeeds." "ultrapathPlugin"
	    else
	        print_debug "There are no earlier UltraPath-for-vCenter dir." "ultrapathPlugin"
	    fi
	    cd ${i10s_baseDir}	
				
    fi
	
fi

#5.װrpm
    i10s_installForRPM
    if [ $? -ne 0 ]
    then
	   print_error "1040" "Installing UltraPath for vCenter failed!"
       i10s_oldUltraPathType=""
       i10s_uninstallOldUltraPath
       i10s_exit 3
    else
	    chown -R vsphere-client /etc/vmware/vsphere-client/vc-packages/
	    chgrp -R users /etc/vmware/vsphere-client/vc-packages/
		chmod -R 700 /etc/vmware/vsphere-client/vc-packages/
		
        i10s_importOEM
		print_event "1040" "UltraPath for vCenter has been successfully installed.Please make sure register the UltraPath for vCenter plug-in to make the UltraPath for vCenter plug-in effective."
		g10s_unlockShell "${i10s_lockFile}"
    fi





